import { zodResolver } from '@hookform/resolvers/zod'
import { data } from 'react-router'
import { getValidatedFormData } from 'remix-hook-form'
import { XiorError } from 'xior'

import { newsLoginRequest } from '~/apis/news/login'
import { loginSchema, type TLoginSchema } from '~/layouts/news/form-login'
import { generateTokenCookie } from '~/utils/token'

import type { Route } from './+types/actions.login'

export const action = async ({ request }: Route.ActionArgs) => {
  try {
    const {
      errors,
      data: payload,
      receivedValues: defaultValues,
    } = await getValidatedFormData<TLoginSchema>(
      request,
      zodResolver(loginSchema),
      false,
    )

    if (errors) {
      return data({ success: false, errors, defaultValues }, { status: 400 })
    }

    const { data: loginData } = await newsLoginRequest(payload)
    const { token } = loginData
    const tokenCookie = generateTokenCookie({
      token,
    })

    const headers = new Headers()
    headers.append('Set-Cookie', await tokenCookie)

    return data(
      {
        success: true,
      },
      {
        headers,
        status: 200,
        statusText: 'OK',
      },
    )
  } catch (error) {
    if (error instanceof XiorError) {
      return data(
        {
          success: false,
          message: error?.response?.data?.error?.message || error.message,
        },
        {
          status: error?.response?.status || 500,
        },
      )
    }
    return data(
      {
        success: false,
        message: 'Internal server error',
      },
      { status: 500 },
    )
  }
}
